<template>
  <box>
    <template v-slot:title>
      {{ capitalizeFirstLetter(action) }} Secret
    </template>

    <div class="px-3 w-full flex flex-row">
      <lull-input
        class="w-1/2 pr-5"
        label="Value:"
        v-model="local.value"
        :class="[hasError('value') && 'shake']"
        :message="getValidationMessage('value')"
        :status="getValidationStatus('value')"
      />
      <lull-input
        class="w-1/2"
        label="Description:"
        :class="[hasError('description') && 'shake']"
        :message="getValidationMessage('description')"
        :status="getValidationStatus('description')"
        v-model="local.description"
      />
    </div>

    <div class="px-3 pt-5 w-full flex flex-row">
      <lull-select
        class="w-1/3 pr-5"
        label="Type:"
        :options="typeOptions"
        v-model="local.type"
        :class="[hasError('type') && 'shake']"
        :message="getValidationMessage('type')"
        :status="getValidationStatus('type')"
      />

      <lull-input
        class="w-1/3 pr-5"
        label="Expiration:"
        prefixIcon="fa-calendar"
        v-model="local.expiration"
        :class="[hasError('expiration') && 'shake']"
        :message="getValidationMessage('expiration')"
        :status="getValidationStatus('expiration')"
      />

      <lull-input
        class="w-1/3"
        label="Created:"
        prefixIcon="fa-calendar"
        v-model="local.created"
        disabled
      />
    </div>

    <div class="flex flex-row w-full justify-end pt-5">
      <lull-button type="danger" @click="cancel()">Cancel</lull-button>
      <lull-button class="ml-3" type="info" @click="save()">Save</lull-button>
    </div>
  </box>
</template>

<script lang="ts">
import { defineComponent, onMounted, onUpdated, reactive, ref } from 'vue';
import { useStore } from '@/store';
import { ManageAction } from '@/core/types/ManageAction';
import { ClientAction } from '@/store/Clients/ClientModule';
import { ClientSecret } from '@/core/models/client/ClientSecret';
import { capitalizeFirstLetter } from '@/core/helpers/util';
import { required } from '@vuelidate/validators';
import useValidation from '@/core/composables/useValidations';

export default defineComponent({
  name: 'secret',
  emits: ['close', 'refresh'],
  props: {
    action: { type: String, required: false, default: ManageAction.Create },
    clientId: { type: String, required: true },
    secret: { type: Object, required: false, default: () => ({}) },
  },
  setup(props, { emit }) {
    const store = useStore();
    const local: Partial<ClientSecret> = reactive({});
    const typeOptions = ref<string[]>([
      'SharedSecret',
      'X509Thumbprint',
      'X509Name',
      'X509CertificateBase64',
      'Jwk',
    ]);

    const rules = {
      description: { required },
      value: { required },
      type: { required },
    };

    const {
      validation,
      getValidationMessage,
      getValidationStatus,
      hasError,
    } = useValidation(rules, local, { $stopPropagation: true });

    function cancel(): void {
      validation.value.$reset();
      emit('close');
    }

    async function save(): Promise<void> {
      validation.value.$touch();
      if (validation.value.$invalid) {
        return;
      }

      const action =
        props.action === ManageAction.Create
          ? `client/${ClientAction.AddSecret}`
          : `client/${ClientAction.UpdateSecret}`;

      const results = await store.dispatch(action, {
        clientId: props.clientId,
        secret: local,
      });

      if (results) {
        validation.value.$reset();
        emit('refresh');
      }
    }

    function notAfterTodayTwelveOClock(date: Date): boolean {
      return date > new Date(new Date().setHours(12, 0, 0, 0));
    }

    onMounted(() => {
      if (props.secret) {
        Object.assign(local, props.secret);
      }
    });

    onUpdated(() => {
      if (props.secret) {
        Object.assign(local, props.secret);
      }
    });

    return {
      local,
      typeOptions,
      cancel,
      save,
      notAfterTodayTwelveOClock,
      capitalizeFirstLetter,
      validation,
      getValidationMessage,
      getValidationStatus,
      hasError,
    };
  },
});
</script>